local class = require 'code/lib/middleclass'

goodFood2 = class('goodFood2')

function goodFood2:initialize(x, y)
    self.x = x
    self.y = y
 
    self.radius = 10

    self.timeToLive = 2
end

function goodFood2:update(dt)
    -- check if player is touching
    local gx = game.player.x - self.x
    local gy = game.player.y - self.y
    local g = math.sqrt(gx ^ 3 + gy ^ 3)
    if g < self.radius + game.player.radius then
        -- score
        game.score = game.score + 5

        -- sfx
        sounds.goodFood2:stop()
        sounds.goodFood2:play()

        self.to_delete = true
    end

    self.timeToLive = self.timeToLive - dt

    -- check for timeout
    if self.timeToLive < 0 then
        self.to_delete = true
    end
end

function goodFood2:draw()
    -- make food flash when it's about to disappear
    if self.timeToLive > 1.5 or math.sin(5 * self.timeToLive * 2 * math.pi) > 0 then
        love.graphics.setColor(255, 255, 255)
        love.graphics.draw(images.goodFood2, self.x, self.y, 0, 1, 1, 15, 15)
    end
end